import type { IGetExecutePollFunctions, IGetExecuteTriggerFunctions, INode, IWorkflowExecuteAdditionalData, Workflow, WorkflowActivateMode, WorkflowExecuteMode } from 'n8n-workflow';
import type { IWorkflowData } from './Interfaces';
import { ScheduledTaskManager } from './ScheduledTaskManager';
export declare class ActiveWorkflows {
    private readonly scheduledTaskManager;
    constructor(scheduledTaskManager: ScheduledTaskManager);
    private activeWorkflows;
    isActive(workflowId: string): boolean;
    allActiveWorkflows(): string[];
    get(workflowId: string): IWorkflowData;
    add(workflowId: string, workflow: Workflow, additionalData: IWorkflowExecuteAdditionalData, mode: WorkflowExecuteMode, activation: WorkflowActivateMode, getTriggerFunctions: IGetExecuteTriggerFunctions, getPollFunctions: IGetExecutePollFunctions): Promise<void>;
    activatePolling(node: INode, workflow: Workflow, additionalData: IWorkflowExecuteAdditionalData, getPollFunctions: IGetExecutePollFunctions, mode: WorkflowExecuteMode, activation: WorkflowActivateMode): Promise<void>;
    remove(workflowId: string): Promise<boolean>;
    removeAllTriggerAndPollerBasedWorkflows(): Promise<void>;
    private closeTrigger;
}
