import { InstanceSettingsConfig } from './InstanceSettingsConfig';
interface WritableSettings {
    tunnelSubdomain?: string;
}
type InstanceRole = 'unset' | 'leader' | 'follower';
export type InstanceType = 'main' | 'webhook' | 'worker';
export declare class InstanceSettings {
    private readonly config;
    private readonly userHome;
    readonly n8nFolder: string;
    readonly staticCacheDir: string;
    readonly customExtensionDir: string;
    readonly nodesDownloadDir: string;
    private readonly settingsFile;
    readonly enforceSettingsFilePermissions: {
        isSet: boolean;
        enforce: boolean;
    };
    private settings;
    readonly instanceId: string;
    readonly instanceType: InstanceType;
    constructor(config: InstanceSettingsConfig);
    instanceRole: InstanceRole;
    readonly hostId: string;
    get isLeader(): boolean;
    markAsLeader(): void;
    get isFollower(): boolean;
    markAsFollower(): void;
    get encryptionKey(): string;
    get tunnelSubdomain(): string | undefined;
    update(newSettings: WritableSettings): void;
    private getUserHome;
    private loadOrCreate;
    private generateInstanceId;
    private save;
    private loadEnforceSettingsFilePermissionsFlag;
    private ensureSettingsFilePermissions;
    private isWindows;
}
export {};
