"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findTriggerForPartialExecution = findTriggerForPartialExecution;
const assert = __importStar(require("assert/strict"));
function findAllParentTriggers(workflow, destinationNodeName) {
    const parentNodes = workflow
        .getParentNodes(destinationNodeName)
        .map((name) => {
        const node = workflow.getNode(name);
        assert.ok(node);
        return {
            node,
            nodeType: workflow.nodeTypes.getByNameAndVersion(node.type, node.typeVersion),
        };
    })
        .filter((value) => value !== null)
        .filter(({ nodeType }) => nodeType.description.group.includes('trigger'))
        .map(({ node }) => node);
    return parentNodes;
}
function findTriggerForPartialExecution(workflow, destinationNodeName) {
    const parentTriggers = findAllParentTriggers(workflow, destinationNodeName).filter((trigger) => !trigger.disabled);
    const pinnedTriggers = parentTriggers
        .filter((trigger) => workflow.pinData?.[trigger.name])
        .sort((n) => (n.type.endsWith('webhook') ? -1 : 1));
    if (pinnedTriggers.length) {
        return pinnedTriggers[0];
    }
    else {
        return parentTriggers[0];
    }
}
//# sourceMappingURL=findTriggerForPartialExecution.js.map